
'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

'Picaxe 08M and L293B stepper motor driver for UV scanner

'By Downwind 16/01/2010

# picaxe 08m


symbol step_counter = 	w0
symbol marker = 		b2
symbol flag = 		b3
symbol y = 			b4
symbol speed =		b5
symbol passes =		b6
symbol pass_counter =	b7

symbol steps = 		w6

marker = 1



	
	if pin3 = 0 then	'Fast speed test mode
	speed = 10
	goto start
	endif


	goto main


setup:


'%%%%%%%%% SET SPEED HERE ..10 minimum %%%%%%%%%%%%%%

 	speed = 		250

'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
start:
'%%%%%%%%%%% SET NUMBER OF PASSES HERE %%%%%%%%%%%%%%
'
	passes = 		10

'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

'%%%%%%% SET NUMBER OF STEPS HERE (one way)%%%%%%%%%%

	steps = 		550
 
'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 



 
flag = 		1
step_counter = 	0
pass_counter = 	0
marker =		0
y = 			0
 
high 			0,1
low 			2,4



setfreq m8		' set frequency t0 8 megs	



gosub step_10




 
main:  		' Start of program





'%%%%%% WAITS AT END & START OF CYCLE FOR PIN3 BUTTON PRESS %%%%


	if marker = 1 and pin3 = 0 then setup

	If marker = 1 then main

	

'%%%%% BACKSTEP 10 STEPS TO TURN LED SWITCH OFF %%%%%%%%%


	if pass_counter = passes and marker =0 then
	toggle 0,4
	gosub step_10
	low 0,1,2,4
	marker =1
	goto main
	endif

	

'%%%%%% FORWARD STEPPING %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


	if step_counter => steps and flag = 1 then
	step_counter = 0
	inc Pass_counter
	toggle 0,4
	flag = 0
	pause speed

	endif

		

'%%%%%%%%% REVERSE STEPPING %%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
	
	
	if step_counter => steps and flag =0 then
	step_counter = 0
	inc pass_counter
	toggle 0,4
	toggle 1,2
	flag = 1
	pause speed
	endif
	


'%%%%%%%% MAIN STEPPING ROUTINE, 1 step each coil %%%%%%%


	toggle 1,2
	toggle 0,4
	inc step_counter
	pause speed
	toggle 0,4
	inc step_counter
	Pause speed



'%%%%%% ADJUST TRAVEL DISTANCE IN STEPS %%%%%%%%%%%%%%%%%

	
	if pin3 = 0 and step_counter > 50 and flag = 1 then
	steps = step_counter 
	goto main
	endif
	
	
	goto main
	
	

'%%% MOVES CARRIAGE 10 STEPS AT START AND END OF CYCLE %%%


step_10:  
  	
 
  	For y = 0 to 6
	toggle 1,2
	toggle 0,4
	pause speed
	toggle 0,4
	Pause speed
	next y
	
 	return
	
	goto main
	
	
'%%%%%%%%%%%%%%%%%%%%%%% THE END %%%%%%%%%%%%%%%%%%%%%%%%%


